"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tip = void 0;
const react_1 = __importStar(require("react"));
require("../style/Tip.css");
class Tip extends react_1.Component {
    constructor() {
        super(...arguments);
        this.state = {
            compact: true,
            text: "",
            selectedValueForRadio: "",
            selectedValueForSelect: "",
        };
        this.optionsValues = (options) => {
            if (options === undefined) {
                // Case 1: valueOptions prop not set, show nothing
                return undefined;
            }
            if (options.length === 0) {
                // Case 2: valueOptions prop is an empty list, show default options
                return ["💩", "😱", "😍", "🔥", "😳", "⚠️"];
            }
            // Case 3: valueOptions prop is set with a list, show that list
            return options;
        };
    }
    // for TipContainer
    componentDidUpdate(nextProps, nextState) {
        const { onUpdate } = this.props;
        if (onUpdate && this.state.compact !== nextState.compact) {
            onUpdate();
        }
    }
    render() {
        const { onConfirm, onOpen, radioOptions, valueOptions } = this.props;
        const { compact, text, selectedValueForRadio, selectedValueForSelect } = this.state;
        let radioOptionsList = this.optionsValues(radioOptions);
        let options = this.optionsValues(valueOptions);
        return (react_1.default.createElement("div", { className: "Tip" }, compact ? (react_1.default.createElement("div", { className: "Tip__compact", onClick: () => {
                onOpen();
                this.setState({ compact: false });
            } }, "Add highlight")) : (react_1.default.createElement("form", { className: "Tip__card", onSubmit: (event) => {
                event.preventDefault();
                onConfirm({ text, selectedValueForRadio, selectedValueForSelect });
            } },
            react_1.default.createElement("div", null,
                react_1.default.createElement("textarea", { placeholder: "Your comment", autoFocus: true, value: text, onChange: (event) => this.setState({ text: event.target.value }), ref: (node) => {
                        if (node) {
                            node.focus();
                        }
                    } }),
                react_1.default.createElement("div", null, radioOptionsList === null || radioOptionsList === void 0 ? void 0 : radioOptionsList.map((option) => (react_1.default.createElement("label", { key: option, className: "Tip__labelOptions" },
                    react_1.default.createElement("input", { checked: selectedValueForRadio === option, type: "radio", name: "value", value: option, onChange: (event) => this.setState({ selectedValueForRadio: event.target.value }) }),
                    option)))),
                react_1.default.createElement("div", null, options === undefined ? null : (react_1.default.createElement("select", { value: selectedValueForSelect, onChange: (event) => this.setState({ selectedValueForSelect: event.target.value }) },
                    react_1.default.createElement("option", { key: "choose", value: "" }, "Choose..."), options === null || options === void 0 ? void 0 :
                    options.map((option) => (react_1.default.createElement("option", { key: option, value: option }, option))))))),
            react_1.default.createElement("div", null,
                react_1.default.createElement("input", { type: "submit", value: "Save" }))))));
    }
}
exports.Tip = Tip;
exports.default = Tip;
//# sourceMappingURL=Tip.js.map