import React, { Component } from "react";
import "../style/Tip.css";
export class Tip extends Component {
    constructor() {
        super(...arguments);
        this.state = {
            compact: true,
            text: "",
            selectedValueForRadio: "",
            selectedValueForSelect: "",
        };
        this.optionsValues = (options) => {
            if (options === undefined) {
                // Case 1: valueOptions prop not set, show nothing
                return undefined;
            }
            if (options.length === 0) {
                // Case 2: valueOptions prop is an empty list, show default options
                return ["💩", "😱", "😍", "🔥", "😳", "⚠️"];
            }
            // Case 3: valueOptions prop is set with a list, show that list
            return options;
        };
    }
    // for TipContainer
    componentDidUpdate(nextProps, nextState) {
        const { onUpdate } = this.props;
        if (onUpdate && this.state.compact !== nextState.compact) {
            onUpdate();
        }
    }
    render() {
        const { onConfirm, onOpen, radioOptions, valueOptions } = this.props;
        const { compact, text, selectedValueForRadio, selectedValueForSelect } = this.state;
        let radioOptionsList = this.optionsValues(radioOptions);
        let options = this.optionsValues(valueOptions);
        return (React.createElement("div", { className: "Tip" }, compact ? (React.createElement("div", { className: "Tip__compact", onClick: () => {
                onOpen();
                this.setState({ compact: false });
            } }, "Add highlight")) : (React.createElement("form", { className: "Tip__card", onSubmit: (event) => {
                event.preventDefault();
                onConfirm({ text, selectedValueForRadio, selectedValueForSelect });
            } },
            React.createElement("div", null,
                React.createElement("textarea", { placeholder: "Your comment", autoFocus: true, value: text, onChange: (event) => this.setState({ text: event.target.value }), ref: (node) => {
                        if (node) {
                            node.focus();
                        }
                    } }),
                React.createElement("div", null, radioOptionsList === null || radioOptionsList === void 0 ? void 0 : radioOptionsList.map((option) => (React.createElement("label", { key: option, className: "Tip__labelOptions" },
                    React.createElement("input", { checked: selectedValueForRadio === option, type: "radio", name: "value", value: option, onChange: (event) => this.setState({ selectedValueForRadio: event.target.value }) }),
                    option)))),
                React.createElement("div", null, options === undefined ? null : (React.createElement("select", { value: selectedValueForSelect, onChange: (event) => this.setState({ selectedValueForSelect: event.target.value }) },
                    React.createElement("option", { key: "choose", value: "" }, "Choose..."), options === null || options === void 0 ? void 0 :
                    options.map((option) => (React.createElement("option", { key: option, value: option }, option))))))),
            React.createElement("div", null,
                React.createElement("input", { type: "submit", value: "Save" }))))));
    }
}
export default Tip;
//# sourceMappingURL=Tip.js.map